#include "opencv2/highgui/highgui.hpp"
#include "opencv2/imgproc/imgproc.hpp"
#include "hough.h"

#include <iostream>

using namespace cv;
using namespace std;

#define     BLURRING
#define     CANNY
//#define     PIXEL_COUNT
//#define     SHOW_IMG
//#define     WRITE_IMG

typedef struct _hough_param
{
    cv::Mat img;
    int edge_pixel_count;
} hough_param;

void* hough_make_wcet_param(void)
{
    return malloc(sizeof(hough_param));
}

void hough_preproc(void *args, void *output)
{
    hough_param *out_info = (hough_param*) args;

    //const char* filename = argv[1];

    Mat src = imread("ntnu_001.jpg", 0);
    if(src.empty()){
        //cout << "can not open " << filename << endl;
        return;
    }

#ifdef      BLURRING
    Mat dst, cdst, bdst;
    blur(src, bdst, Size(3,3));
#endif

#ifdef      CANNY
    Canny(bdst, dst, 80, 200, 3);
#endif
#if defined(SHOW_IMG) || defined(WRITE_IMG)
    cvtColor(dst, cdst, CV_GRAY2BGR);
#endif
#ifdef      PIXEL_COUNT
    cout << "Number of white pixels: " << countNonZero(dst) << endl;
#endif
    
    out_info->img = dst;

    out_info->edge_pixel_count = countNonZero(dst);
}

unsigned int hough_estimator_1(void *args)
{
    hough_param *input = (hough_param*) args;
    return (((3.0*input->edge_pixel_count)/3500000) + 0.1);
}

void hough_transform_1(void *args)
{
    hough_param *input = (hough_param*) args;

    vector<Vec2f> lines;
    HoughLines(input->img, lines, 1, CV_PI/180, 500, 0, 0 );
    cout << "HEI" << endl;
/*
#if defined(SHOW_IMG) || defined(WRITE_IMG)
    for( size_t i = 0; i < lines.size(); i++ ){
        float rho = lines[i][0], theta = lines[i][1];
        Point pt1, pt2;
        double a = cos(theta), b = sin(theta);
        double x0 = a*rho, y0 = b*rho;
        pt1.x = cvRound(x0 + 1000*(-b));
        pt1.y = cvRound(y0 + 1000*(a));
        pt2.x = cvRound(x0 - 1000*(-b));
        pt2.y = cvRound(y0 - 1000*(a));
        line( cdst, pt1, pt2, Scalar(0,0,255), 3, CV_AA);
    }
#endif
*/
}
