#ifndef LIST_H_D06VITK3
#define LIST_H_D06VITK3

typedef struct _list_element
{
    void *content;
    struct _list_element *next;
    struct _list_element *prev;
} list_element;

typedef struct _list
{
    list_element *first_element;
    list_element *current_element;
    list_element *last_element;
    unsigned int n_elements;
} linked_list;

void list_init(linked_list* list);

void list_add_element(linked_list *list, void* content);

void list_add_element_before_current(linked_list *list, void* content);

void* list_get_current(linked_list *list);

void list_remove_by_content(linked_list *list, void* content);

void* list_get_next(linked_list *list);

void* list_remove_current(linked_list *list);

void list_destroy(linked_list *list);
#endif /* end of include guard: LIST_H_D06VITK3 */

