#include <stdio.h>
#include <unistd.h>
#include "task.h"
#include "sched.h"


void task_func(void *args)
{
    int number = 0;
    char *var_name = (char*) args;

    printf("%s: %d\n", var_name, number++);
}

unsigned int wcet_est(void *args)
{
    return *((unsigned int*) args);    
}

int main(int argc, char *argv[])
{
    
    task_tcb task_1, task_2;
    task_variant taskvar_1a, taskvar_1b, taskvar_1c, taskvar_2a, taskvar_2b;
    unsigned int estimates[3] = {50, 20, 5}; 

    task_init(&task_1, "TASK_1", 1, 100, 1, NULL, NULL);
    task_variant_init(&taskvar_1a, &task_func, "1A", &wcet_est, (void*)estimates);
    task_variant_init(&taskvar_1b, &task_func, "1B", &wcet_est, (void*)(estimates + 1));
    task_variant_init(&taskvar_1c, &task_func, "1C", &wcet_est, (void*)(estimates + 2));
    task_add_variant(&task_1, &taskvar_1a);
    task_add_variant(&task_1, &taskvar_1b);
    task_add_variant(&task_1, &taskvar_1c);

    task_init(&task_2, "TASK_2", 1, 70, 2, NULL, NULL);
    task_variant_init(&taskvar_2a, &task_func, "2A", &wcet_est, (void*)estimates);
    task_variant_init(&taskvar_2b, &task_func, "2B", &wcet_est, (void*)(estimates + 1));
    task_add_variant(&task_2, &taskvar_2a);
    task_add_variant(&task_2, &taskvar_2b);

    sched_init();

    sched_register_task(&task_1, 1000);
    sched_register_task(&task_2, 2000);

    sched_start();

    return 0;
}
