#include <stdio.h>
#include <unistd.h>
#include "task.h"


void task_func(void *args)
{
    int number = 0;
    char *var_name = (char*) args;
    while(1) {
        printf("%s: %d\n", var_name, number++);
        sleep(1);
    }
}

unsigned int wcet_est(void *args)
{
    return *((unsigned int*) args);    
}

int main(int argc, char *argv[])
{
    
    task_tcb task_1, task_2;
    task_variant taskvar_1a, taskvar_1b, taskvar_1c, taskvar_2a, taskvar_2b;
    unsigned int estimates[3] = {50, 20, 5}; 

    task_init(&task_1, "TASK_1", 1, 100,1, NULL, NULL);
    task_variant_init(&taskvar_1a, &task_func, "1A", &wcet_est, (void*)estimates);
    task_variant_init(&taskvar_1b, &task_func, "1B", &wcet_est, (void*)(estimates + 1));
    task_variant_init(&taskvar_1c, &task_func, "1C", &wcet_est, (void*)(estimates + 2));
    task_add_variant(&task_1, &taskvar_1a);
    task_add_variant(&task_1, &taskvar_1b);
    task_add_variant(&task_1, &taskvar_1c);

    task_init(&task_2, "TASK_2", 2, 70, 2, NULL, NULL);
    task_variant_init(&taskvar_2a, &task_func, "2A", &wcet_est, (void*)estimates);
    task_variant_init(&taskvar_2b, &task_func, "2B", &wcet_est, (void*)(estimates + 1));
    task_add_variant(&task_2, &taskvar_2a);
    task_add_variant(&task_2, &taskvar_2b);


    task_start(&task_1);

    getchar();

    task_suspend(&task_1);

    printf("Time estiate: %d\n", task_get_wcet(&task_1));

    getchar();

    task_start(&task_1);

    getchar();

    task_suspend(&task_1);

    getchar();

    task_use_next_variant(&task_1);

    printf("Time estiate: %d\n", task_get_wcet(&task_1));

    getchar();

    task_start(&task_1);

    getchar();

    task_suspend(&task_1);

    getchar();

    task_start(&task_2);

    getchar();

    task_suspend(&task_2);

    getchar();

    task_start(&task_1);

    getchar();

    task_destroy(&task_1);
    task_destroy(&task_2);
    
    return 0;
}
